searchNodes=[{"doc":"Gathers supported currency listing and conversion functions","ref":"PTAX.html","title":"PTAX","type":"module"},{"doc":"Returns a list of supported currencies Examples iex&gt; PTAX . currencies ( ) { :ok , ~w[GBP EUR USD]a }","ref":"PTAX.html#currencies/0","title":"PTAX.currencies/0","type":"function"},{"doc":"Similar to exchange/2 , but throws an error if the amount cannot be converted. Examples iex&gt; PTAX . exchange! ( PTAX.Money . new ( 10 , :USD ) , to : :BRL , date : ~D[2021-12-24] ) PTAX.Money . new ( &quot;56.541&quot; , :BRL ) iex&gt; PTAX . exchange! ( PTAX.Money . new ( &quot;15.45&quot; , :USD ) , to : :GBP , date : ~D[2021-12-24] ) PTAX.Money . new ( &quot;11.5247&quot; , :GBP ) iex&gt; PTAX . exchange! ( PTAX.Money . new ( &quot;15.45&quot; , :USD ) , to : :GBPS , date : ~D[2021-12-24] ) ** (PTAX.Error) Unknown error","ref":"PTAX.html#exchange!/2","title":"PTAX.exchange!/2","type":"function"},{"doc":"Converts a value from one currency to another Examples iex&gt; PTAX . exchange ( PTAX.Money . new ( 5 , :USD ) , to : :GBP , date : ~D[2021-12-24] ) { :ok , PTAX.Money . new ( &quot;3.7297&quot; , :GBP ) } iex&gt; PTAX . exchange ( PTAX.Money . new ( &quot;546.56&quot; , :GBP ) , to : :USD , date : ~D[2021-12-24] ) { :ok , PTAX.Money . new ( &quot;732.4997&quot; , :USD ) } iex&gt; PTAX . exchange ( PTAX.Money . new ( &quot;15.69&quot; , :EUR ) , to : :GBP , date : ~D[2021-12-24] ) { :ok , PTAX.Money . new ( &quot;13.2474&quot; , :GBP ) }","ref":"PTAX.html#exchange/2","title":"PTAX.exchange/2","type":"function"},{"doc":"","ref":"PTAX.html#t:currency/0","title":"PTAX.currency/0","type":"type"},{"doc":"","ref":"PTAX.html#t:error/0","title":"PTAX.error/0","type":"type"},{"doc":"","ref":"PTAX.html#t:exchange_opts/0","title":"PTAX.exchange_opts/0","type":"type"},{"doc":"","ref":"PTAX.html#t:money/0","title":"PTAX.money/0","type":"type"},{"doc":"Defines a Money structure for working with currencies.","ref":"PTAX.Money.html","title":"PTAX.Money","type":"module"},{"doc":"Exchange from a currency to another given the rate. Examples: iex&gt; PTAX.Money . exchange ( PTAX.Money . new ( 10 , :USD ) , PTAX.Money.Pair . new ( 5 , &quot;5.5&quot; , :USD , :BRL ) ) PTAX.Money . new ( 50 , :BRL ) iex&gt; PTAX.Money . exchange ( PTAX.Money . new ( 1 , :USD ) , PTAX.Money.Pair . new ( &quot;1.5&quot; , 2 , :GBP , :USD ) ) PTAX.Money . new ( &quot;0.5&quot; , :GBP ) iex&gt; PTAX.Money . exchange ( PTAX.Money . new ( 115 , :JPY ) , PTAX.Money.Pair . new ( &quot;114.5&quot; , 115 , :USD , :JPY ) ) PTAX.Money . new ( 1 , :USD ) iex&gt; PTAX.Money . exchange ( PTAX.Money . new ( 1 , :USD ) , PTAX.Money.Pair . new ( &quot;114.5&quot; , 115 , :USD , :JPY ) ) PTAX.Money . new ( &quot;114.5&quot; , :JPY )","ref":"PTAX.Money.html#exchange/2","title":"PTAX.Money.exchange/2","type":"function"},{"doc":"Create a new Money given the amount and currency. Examples: iex&gt; PTAX.Money . new ( 10 ) % PTAX.Money { amount : PTAX.Money . to_amount ( 10 ) , currency : :BRL } iex&gt; PTAX.Money . new ( &quot;12.75&quot; , :USD ) % PTAX.Money { amount : PTAX.Money . to_amount ( &quot;12.75&quot; ) , currency : :USD } iex&gt; PTAX.Money . new ( 123 , :GBP ) % PTAX.Money { amount : PTAX.Money . to_amount ( 123 ) , currency : :GBP }","ref":"PTAX.Money.html#new/2","title":"PTAX.Money.new/2","type":"function"},{"doc":"","ref":"PTAX.Money.html#to_amount/2","title":"PTAX.Money.to_amount/2","type":"function"},{"doc":"","ref":"PTAX.Money.html#t:amount/0","title":"PTAX.Money.amount/0","type":"type"},{"doc":"","ref":"PTAX.Money.html#t:currency/0","title":"PTAX.Money.currency/0","type":"type"},{"doc":"","ref":"PTAX.Money.html#t:pair/0","title":"PTAX.Money.pair/0","type":"type"},{"doc":"","ref":"PTAX.Money.html#t:t/0","title":"PTAX.Money.t/0","type":"type"},{"doc":"Defines a Currency Pair structure.","ref":"PTAX.Money.Pair.html","title":"PTAX.Money.Pair","type":"module"},{"doc":"Combines two currency pairs, based on their common currency Examples: # Type A / Type A iex&gt; PTAX.Money.Pair . combine ( PTAX.Money.Pair . new ( 6.5673 , 6.5691 , :USD , :DKK ) , PTAX.Money.Pair . new ( 8.8365 , 8.8395 , :USD , :NOK ) ) PTAX.Money.Pair . new ( 1.3459869 , 1.3451614 , :DKK , :NOK ) # Type A / Type B iex&gt; PTAX.Money.Pair . combine ( PTAX.Money.Pair . new ( 1.2813 , 1.2815 , :USD , :CAD ) , PTAX.Money.Pair . new ( 0.7232 , 0.7236 , :AUD , :USD ) ) PTAX.Money.Pair . new ( 1.0791722 , 1.0791722 , :CAD , :AUD ) # Type B / Type A iex&gt; PTAX.Money.Pair . combine ( PTAX.Money.Pair . new ( 1.3402 , 1.3406 , :GBP , :USD ) , PTAX.Money.Pair . new ( 0.9185 , 0.9192 , :USD , :CHF ) ) PTAX.Money.Pair . new ( 1.2309737 , 1.2309737 , :GBP , :CHF ) # Type B / Type B iex&gt; PTAX.Money.Pair . combine ( PTAX.Money.Pair . new ( 1.3402 , 1.3406 , :GBP , :USD ) , PTAX.Money.Pair . new ( 1.1319 , 1.1323 , :EUR , :USD ) ) PTAX.Money.Pair . new ( 1.1836086 , 1.1843802 , :GBP , :EUR )","ref":"PTAX.Money.Pair.html#combine/2","title":"PTAX.Money.Pair.combine/2","type":"function"},{"doc":"Create a new currency pair. Examples: iex&gt; PTAX.Money.Pair . new ( 2 , 2.1 , :GBP , :USD ) % PTAX.Money.Pair { amount : %{ bid : PTAX.Money . to_amount ( 2 ) , ask : PTAX.Money . to_amount ( &quot;2.1&quot; ) } , base_currency : :GBP , quoted_currency : :USD }","ref":"PTAX.Money.Pair.html#new/4","title":"PTAX.Money.Pair.new/4","type":"function"},{"doc":"","ref":"PTAX.Money.Pair.html#t:t/0","title":"PTAX.Money.Pair.t/0","type":"type"},{"doc":"Define a quotation structure for a currency","ref":"PTAX.Quotation.html","title":"PTAX.Quotation","type":"module"},{"doc":"Returns the quotation of a currency for the date Examples iex&gt; PTAX.Quotation . get ( :USD , ~D[2021-12-24] ) { :ok , % PTAX.Quotation { pair : PTAX.Money.Pair . new ( &quot;1.0&quot; , &quot;1.0&quot; , :USD , :USD ) , quoted_in : DateTime . from_naive! ( ~N[2021-12-24 11:04:02.178] , &quot;America/Sao_Paulo&quot; ) , bulletin : PTAX.Quotation.Bulletin.Closing } }","ref":"PTAX.Quotation.html#get/3","title":"PTAX.Quotation.get/3","type":"function"},{"doc":"Returns a quotation list of a currency for a period Examples iex&gt; PTAX.Quotation . list ( :GBP , Date . range ( ~D[2021-12-24] , ~D[2021-12-24] ) ) { :ok , [ % PTAX.Quotation { pair : PTAX.Money.Pair . new ( &quot;1.3417&quot; , &quot;1.3421&quot; , :GBP , :USD ) , quoted_in : DateTime . from_naive! ( ~N[2021-12-24 10:08:31.922] , &quot;America/Sao_Paulo&quot; ) , bulletin : PTAX.Quotation.Bulletin.Opening } , % PTAX.Quotation { pair : PTAX.Money.Pair . new ( &quot;1.3402&quot; , &quot;1.3406&quot; , :GBP , :USD ) , quoted_in : DateTime . from_naive! ( ~N[2021-12-24 11:04:02.173] , &quot;America/Sao_Paulo&quot; ) , bulletin : PTAX.Quotation.Bulletin.Intermediary } , % PTAX.Quotation { pair : PTAX.Money.Pair . new ( &quot;1.3402&quot; , &quot;1.3406&quot; , :GBP , :USD ) , quoted_in : DateTime . from_naive! ( ~N[2021-12-24 11:04:02.178] , &quot;America/Sao_Paulo&quot; ) , bulletin : PTAX.Quotation.Bulletin.Closing } ] }","ref":"PTAX.Quotation.html#list/3","title":"PTAX.Quotation.list/3","type":"function"},{"doc":"","ref":"PTAX.Quotation.html#t:t/0","title":"PTAX.Quotation.t/0","type":"type"},{"doc":"","ref":"PTAX.Quotation.Bulletin.html","title":"PTAX.Quotation.Bulletin","type":"module"},{"doc":"","ref":"PTAX.Quotation.Bulletin.html#default/0","title":"PTAX.Quotation.Bulletin.default/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.html#enums/0","title":"PTAX.Quotation.Bulletin.enums/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.html#from/1","title":"PTAX.Quotation.Bulletin.from/1","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.html#options/0","title":"PTAX.Quotation.Bulletin.options/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.html#value/1","title":"PTAX.Quotation.Bulletin.value/1","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.html#values/0","title":"PTAX.Quotation.Bulletin.values/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.html#t:t/0","title":"PTAX.Quotation.Bulletin.t/0","type":"type"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Closing.html","title":"PTAX.Quotation.Bulletin.Closing","type":"module"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Closing.html#downcase_value/0","title":"PTAX.Quotation.Bulletin.Closing.downcase_value/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Closing.html#upcase_value/0","title":"PTAX.Quotation.Bulletin.Closing.upcase_value/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Closing.html#value/0","title":"PTAX.Quotation.Bulletin.Closing.value/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Closing.html#t:t/0","title":"PTAX.Quotation.Bulletin.Closing.t/0","type":"type"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Intermediary.html","title":"PTAX.Quotation.Bulletin.Intermediary","type":"module"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Intermediary.html#downcase_value/0","title":"PTAX.Quotation.Bulletin.Intermediary.downcase_value/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Intermediary.html#upcase_value/0","title":"PTAX.Quotation.Bulletin.Intermediary.upcase_value/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Intermediary.html#value/0","title":"PTAX.Quotation.Bulletin.Intermediary.value/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Intermediary.html#t:t/0","title":"PTAX.Quotation.Bulletin.Intermediary.t/0","type":"type"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Opening.html","title":"PTAX.Quotation.Bulletin.Opening","type":"module"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Opening.html#downcase_value/0","title":"PTAX.Quotation.Bulletin.Opening.downcase_value/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Opening.html#upcase_value/0","title":"PTAX.Quotation.Bulletin.Opening.upcase_value/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Opening.html#value/0","title":"PTAX.Quotation.Bulletin.Opening.value/0","type":"function"},{"doc":"","ref":"PTAX.Quotation.Bulletin.Opening.html#t:t/0","title":"PTAX.Quotation.Bulletin.Opening.t/0","type":"type"},{"doc":"Make HTTP requests to the PTAX API","ref":"PTAX.Requests.html","title":"PTAX.Requests","type":"module"},{"doc":"","ref":"PTAX.Requests.html#response/1","title":"PTAX.Requests.response/1","type":"function"},{"doc":"","ref":"PTAX.Error.html","title":"PTAX.Error","type":"exception"},{"doc":"","ref":"PTAX.Error.html#new/1","title":"PTAX.Error.new/1","type":"function"},{"doc":"","ref":"PTAX.Error.html#t:t/0","title":"PTAX.Error.t/0","type":"type"},{"doc":"This package is for learning purposes and its use in production is not yet recommended. A currency converter that uses the API provided by the Brazilian Open Data Portal to perform quotes","ref":"readme.html","title":"PTAX","type":"extras"},{"doc":"This package can be installed by adding ptax to your list of dependencies in mix.exs : def deps do [ { :ptax , &quot;~&gt; 0.1&quot; } ] end","ref":"readme.html#installation","title":"PTAX - Installation","type":"extras"},{"doc":"Install and configure a Tesla adapter: # config/config.exs config :tesla , adapter : Tesla.Adapter.Hackney See Tesla installation and adapters docs.","ref":"readme.html#configuration","title":"PTAX - Configuration","type":"extras"},{"doc":"Listing supported currencies iex&gt; PTAX . currencies ( ) { :ok , [ :EUR , :GBP , ... ] } Listing a currency quotation for a date range iex&gt; PTAX.Quotation . list ( :GBP , Date . range ( ~D[2021-12-24] , ~D[2021-12-26] ) ) { :ok , [ % PTAX.Quotation { ... } , ... ] } Getting a currency quotation for a specific date and bulletin iex&gt; PTAX.Quotation . get ( :GBP , ~D[2021-12-24] , PTAX.Quotation.Bulletin.Closing ) { :ok , % PTAX.Quotation { ... } } Exchange a currency amount to another iex&gt; PTAX . exchange ( PTAX.Money . new ( 5 , :GBP ) , to : :EUR , date : ~D[2021-12-24] ) { :ok , # Money &lt; 5.918 , EUR &gt; } Combine two currency pairs, based on USD as the common currency iex&gt; alias PTAX.Money.Pair ...&gt; gbp_usd = Pair . new ( 1.3402 , 1.3406 , :GBP , :USD ) ...&gt; eur_usd = Pair . new ( 1.1319 , 1.1323 , :EUR , :USD ) ...&gt; Pair . combine ( gbp_usd , eur_usd ) # Money.Pair &lt; 1.1836086 / 1.1843802 , GBP / EUR &gt;","ref":"readme.html#usage","title":"PTAX - Usage","type":"extras"},{"doc":"iex&gt; alias PTAX.Money ...&gt; pair = Money.Pair . new ( 1.1836086 , 1.1843802 , :GBP , :EUR ) ...&gt; Money . exchange ( Money . new ( 5 , :GBP ) , pair ) # Money &lt; 5.918 , EUR &gt; ...&gt; Money . exchange ( Money . new ( 5 , :EUR ) , pair ) # Money &lt; 4.2216 , GBP &gt;","ref":"readme.html#exchange-a-currency-amount-given-the-currency-pair","title":"PTAX - Exchange a currency amount given the currency pair","type":"extras"}]